# Source code

    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one
    003 * or more contributor license agreements.  See the NOTICE file
    004 * distributed with this work for additional information
    005 * regarding copyright ownership.  The ASF licenses this file
    006 * to you under the Apache License, Version 2.0 (the
    007 * "License"); you may not use this file except in compliance
    008 * with the License.  You may obtain a copy of the License at
    009 *
    010 * http://www.apache.org/licenses/LICENSE-2.0
    011 *
    012 * Unless required by applicable law or agreed to in writing,
    013 * software distributed under the License is distributed on an
    014 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015 * KIND, either express or implied.  See the License for the
    016 * specific language governing permissions and limitations
    017 * under the License.
    018 */
    019package org.apache.commons.compress.archivers.jar;
    020
    021import java.io.IOException;
    022import java.io.InputStream;
    023
    024import org.apache.commons.compress.archivers.ArchiveEntry;
    025import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
    026import org.apache.commons.compress.archivers.zip.ZipArchiveInputStream;
    027
    028/**
    029 * Implements an input stream that can read entries from jar files.
    030 *
    031 * @NotThreadSafe
    032 */
    033public class JarArchiveInputStream extends ZipArchiveInputStream {
    034
    035    /**
    036     * Creates an instance from the input stream using the default encoding.
    037     *
    038     * @param inputStream the input stream to wrap
    039     */
    040    public JarArchiveInputStream( final InputStream inputStream ) {
    041        super(inputStream);
    042    }
    043
    044    /**
    045     * Creates an instance from the input stream using the specified encoding.
    046     *
    047     * @param inputStream the input stream to wrap
    048     * @param encoding the encoding to use
    049     * @since 1.10
    050     */
    051    public JarArchiveInputStream( final InputStream inputStream, final String encoding ) {
    052        super(inputStream, encoding);
    053    }
    054
    055    public JarArchiveEntry getNextJarEntry() throws IOException {
    056        final ZipArchiveEntry entry = getNextZipEntry();
    057        return entry == null ? null : new JarArchiveEntry(entry);
    058    }
    059
    060    @Override
    061    public ArchiveEntry getNextEntry() throws IOException {
    062        return getNextJarEntry();
    063    }
    064
    065    /**
    066     * Checks if the signature matches what is expected for a jar file
    067     * (in this case it is the same as for a zip file).
    068     *
    069     * @param signature
    070     *            the bytes to check
    071     * @param length
    072     *            the number of bytes to check
    073     * @return true, if this stream is a jar archive stream, false otherwise
    074     */
    075    public static boolean matches(final byte[] signature, final int length ) {
    076        return ZipArchiveInputStream.matches(signature, length);
    077    }
    078}